// ------------------------------- //
// -------- Start of File -------- //
// ------------------------------- //
// ----------------------------------------------------------- //
// C++ Header File Name: dbtcfg.h 
// Compiler Used: MSVC40, DJGPP 2.7.2.1, GCC 2.7.2.1, HP CPP 10.24
// Produced By: Doug Gaer   
// File Creation Date: 09/17/1997  
// Date Last Modified: 03/26/1999
// Copyright (c) 1997 Douglas M. Gaer
// ----------------------------------------------------------- // 
// ---------- Include File Description and Details  ---------- // 
// ----------------------------------------------------------- // 
/*
The VBD C++ classes are copyright (c) 1997, by Douglas M. Gaer.
All those who put this code or its derivatives in a commercial
product MUST mention this copyright in their documentation for
users of the products in which this code or its derivative
classes are used. Otherwise, you have the freedom to redistribute
verbatim copies of this source code, adapt it to your specific
needs, or improve the code and release your improvements to the
public provided that the modified files carry prominent notices
stating that you changed the files and the date of any change.

THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND.
THE ENTIRE RISK OF THE QUALITY AND PERFORMANCE OF THIS SOFTWARE
IS WITH YOU. SHOULD ANY ELEMENT OF THIS SOFTWARE PROVE DEFECTIVE,
YOU WILL ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR, OR
CORRECTION.

Modify this file to customize the string database's user
interface program. 
*/
// ----------------------------------------------------------- //   
#ifndef __DBTCFG_HPP
#define __DBTCFG_HPP

// Program's title used in main menu for curses (terminal) program
const char *MMTitle = "------- LAN DATABASE PROGRAM'S MAIN MENU -------" ;

// Program's name
const char *ProgramName = "LAN Database";

// Configuration file information
#ifdef __UNIX__
const char *DefaultCfgFile = ".landb"; // Default  user configuration file
#endif

#ifdef __DOS__
const char *DefaultCfgFile = "landb.ini"; // Default  user configuration file
#endif

const char *EnvSetting = "LANDBCFG"; // Environment setting for CFG file 

// Default file names
// Do not use any file extensions when creating or opening file.
// Both data and index will share the same name with different
// file extensions. The data file will have a .pod extension and
// the index file will have a .btx extension.
#ifdef __UNIX__
// UNIX file systems use a forward slash (/) for path separators
const char *DefaultDBFileName = "landbx"; // Default DB file
#endif

#ifdef __DOS__
// DOS file systems use a back slash (\\) for path separators
const char *DefaultDBFileName = "landbx"; // Default DB file
#endif

#endif  // __DBTCFG_HPP //
// ----------------------------------------------------------- // 
// ------------------------------- //
// --------- End of File --------- //
// ------------------------------- //
