// ------------------------------- //
// -------- Start of File -------- //
// ------------------------------- //
// ----------------------------------------------------------- //
// C++ Header File Name: machine.h 
// Compiler Used: MSVC40, DJGPP 2.7.2.1, GCC 2.7.2.1, HP CPP 10.24
// Produced By: Doug Gaer  
// File Creation Date: 10/28/1996  
// Date Last Modified: 03/15/1999
// Copyright (c) 1997 Douglas M. Gaer
// ----------------------------------------------------------- // 
// ---------- Include File Description and Details  ---------- // 
// ----------------------------------------------------------- // 
/*
The VBD C++ classes are copyright (c) 1997, by Douglas M. Gaer.
All those who put this code or its derivatives in a commercial
product MUST mention this copyright in their documentation for
users of the products in which this code or its derivative
classes are used. Otherwise, you have the freedom to redistribute
verbatim copies of this source code, adapt it to your specific
needs, or improve the code and release your improvements to the
public provided that the modified files carry prominent notices
stating that you changed the files and the date of any change.

THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND.
THE ENTIRE RISK OF THE QUALITY AND PERFORMANCE OF THIS SOFTWARE
IS WITH YOU. SHOULD ANY ELEMENT OF THIS SOFTWARE PROVE DEFECTIVE,
YOU WILL ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR, OR
CORRECTION.

This file contains macros used to set machine specific flags.
It was developed to make porting code easier by centralizing
all the machine dependent flags.
*/
// ----------------------------------------------------------- //   
#ifndef __MACHINE_HPP
#define __MACHINE_HPP

// Intel x86 family (8088, 286, 386, 486, Pentium) (Littel-Endian)
// ===============================================================
// #ifndef __X86__
// #define __X86__
// #endif  

// Hewlett-Packard's PA-RISC processor (Big-Endian)
// ===============================================================
// #ifndef __PA_RISC__
// #define __PA_RISC__
// #endif  

// Sun's SuperSPARC processor (Big-Endian)
// ===============================================================
// #ifndef __SuperSPARC__
// #define __SuperSPARC__
// #endif 

// Silicon Graphics MIPS processor (Bi-Endian)
// ===============================================================
// #ifndef __SGI_MIPS__
// #define __SGI_MIPS__
// #endif 

// IBM/Motorola PowerPC processors (Bi-Endian)
// ===============================================================
// #ifndef __PowerPC__
// #define __PowerPC__
// #endif 

#endif  // __MACHINE_HPP //
// ----------------------------------------------------------- // 
// ------------------------------- //
// --------- End of File --------- //
// ------------------------------- //
