// ------------------------------- //
// -------- Start of File -------- //
// ------------------------------- //
// ----------------------------------------------------------- //
// C++ Header File Name: os_type.h 
// Compiler Used: MSVC40, DJGPP 2.7.2.1, GCC 2.7.2.1, HP CPP 10.24
// Produced By: Doug Gaer  
// File Creation Date: 10/28/1996  
// Date Last Modified: 03/15/1999
// Copyright (c) 1997 Douglas M. Gaer
// ----------------------------------------------------------- // 
// ---------- Include File Description and Details  ---------- // 
// ----------------------------------------------------------- // 
/*
The VBD C++ classes are copyright (c) 1997, by Douglas M. Gaer.
All those who put this code or its derivatives in a commercial
product MUST mention this copyright in their documentation for
users of the products in which this code or its derivative
classes are used. Otherwise, you have the freedom to redistribute
verbatim copies of this source code, adapt it to your specific
needs, or improve the code and release your improvements to the
public provided that the modified files carry prominent notices
stating that you changed the files and the date of any change.

THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND.
THE ENTIRE RISK OF THE QUALITY AND PERFORMANCE OF THIS SOFTWARE
IS WITH YOU. SHOULD ANY ELEMENT OF THIS SOFTWARE PROVE DEFECTIVE,
YOU WILL ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR, OR
CORRECTION.

This file contains macros used to set Operating System specific
flags within an application. It was developed to make porting
code easier by centralizing all the Operating System dependent
flags.
*/
// ----------------------------------------------------------- //   
#ifndef __OS_TYPE_HPP
#define __OS_TYPE_HPP

// DOS and Windows applications
// #ifndef __DOS__
// #define __DOS__
// #endif 

// Generic Unix applications
// #ifndef __UNIX__
// #define __UNIX__
// #endif 

// Basic console applications for MSDOS and UNIX
// #ifndef __CONSOLE__
// #define __CONSOLE__
// #endif  

// HTML Front End applications
// #ifndef __HTML__
// #define __HTML__
// #endif

// MSDOS applications only
// #ifndef __MSDOS__
// #define __MSDOS__
// #endif 

// Windows API applications
// #ifndef __WINAPI__
// #define __WINAPI__
// #endif 

// Windows MFC applications
// #ifndef __MFC__
// #define __MFC__
// #endif 

// Generic XWINDOWS applications
// #ifndef __XWINDOWS__
// #define __XWINDOWS__
// #endif 

// HP Unix applications
// #ifndef __HPUX__
// #define __HPUX__
// #endif

// Solaris applications
// #ifndef __SOLARIS__
// #define __SOALRIS__
// #endif

// Linux applications
// #ifndef __LINUX__
// #define __LINUX__
// #endif

#endif  // __OS_TYPE_HPP //
// ----------------------------------------------------------- // 
// ------------------------------- //
// --------- End of File --------- //
// ------------------------------- //
