// ------------------------------- //
// -------- Start of File -------- //
// ------------------------------- //
// ----------------------------------------------------------- //
// C++ Header File Name: vbdstats.h
// Compiler Used: MSVC40, DJGPP 2.7.2.1, GCC 2.7.2.1, HP CPP 10.24
// Produced By: Doug Gaer   
// File Creation Date: 02/03/1997  
// Date Last Modified: 03/30/1999
// Copyright (c) 1997 Douglas M. Gaer
// ----------------------------------------------------------- // 
// ---------- Include File Description and Details  ---------- // 
// ----------------------------------------------------------- // 
/*
The VBD C++ classes are copyright (c) 1997, by Douglas M. Gaer.
All those who put this code or its derivatives in a commercial
product MUST mention this copyright in their documentation for
users of the products in which this code or its derivative
classes are used. Otherwise, you have the freedom to redistribute
verbatim copies of this source code, adapt it to your specific
needs, or improve the code and release your improvements to the
public provided that the modified files carry prominent notices
stating that you changed the files and the date of any change.

THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND.
THE ENTIRE RISK OF THE QUALITY AND PERFORMANCE OF THIS SOFTWARE
IS WITH YOU. SHOULD ANY ELEMENT OF THIS SOFTWARE PROVE DEFECTIVE,
YOU WILL ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR, OR
CORRECTION.

The VBD file statistics functions are used to display detailed
file information about the open file This information is used
to analyze and troubleshoot VBD files. 

Changes: 
================================================================
03/30/1999 - Changed the __wxWINDOWS__ macro to __wxWIN168B and
added the __wxWIN201__ macro for wxWindows version 2.0.1
Changed by: Doug Gaer
================================================================
*/
// ----------------------------------------------------------- //
#ifndef __VDBSTATS_HPP__
#define __VBDSTATS_HPP__

// Macros used to select display types 
// ===========================================================
// #ifndef __wxWIN168B__ 
// #define __wxWIN168B__ // wxWindows 1.68B GUI 
// #endif

// #ifndef __wxWIN201__ 
// #define __wxWIN201__ // wxWindows 2.0.1 GUI 
// #endif

// #ifndef __CONSOLE__ 
// #define __CONSOLE__   // Console (stdout) display
// #endif

// #ifndef __CURSES__
// #define __CURSES__    // Curses port for terminal sessions
// #endif
// ===========================================================

#include "vbdfile.h"

#ifdef __CONSOLE__
void VBDStats(const VBDFilePtr &f);
void VBStats(const VBDFilePtr &f, FAU oa);
#endif // __CONSOLE__

#ifdef __CURSES__
class Terminal;
void VBDStats(Terminal *t, const VBDFilePtr &f);
#endif // __CURSES__

#ifdef __wxWIN168B__
class wxTextWindow;
void VBDStats(wxTextWindow *textWin, const VBDFilePtr &f);
void VBStats(wxTextWindow *textWin, const VBDFilePtr &f, FAU oa);
#endif // __wxWIN168B__

#ifdef __wxWIN201__
class wxTextCtrl;
void VBDStats(wxTextCtrl *textWin, const VBDFilePtr &f);
void VBStats(wxTextCtrl *textWin, const VBDFilePtr &f, FAU oa);
#endif // __wxWIN168B__

#endif // __VBDSTATS_HPP__
// ----------------------------------------------------------- //
// ------------------------------- //
// --------- End of File --------- //
// ------------------------------- //
