#######################
#### Start of File ####
#######################
# --------------------------------------------------------------- 
# Makefile Contents: Makefile for the test program
# C/C++ Compiler Used: HP C++ A.10.24  compiled for HP-UX 10.20 
# Produced By: Doug Gaer
# File Creation Date: 03/09/1999 
# Date Last Modified: 04/02/1999
# --------------------------------------------------------------- 
# --------------- Makefile Description and Details -------------- 
# --------------------------------------------------------------- 
# Complier Flags 
#	v   -- Echo compilation
#	g   -- Enable debugging
#	+w  -- Turn on all warnings
#       +eh  -- Enable C++ exception handling
#	+a1 -- Allow ANSI C automatic aggregate initialization	
#	-pta -- Instantiate entire template class
#
#	+DAportable -- Generate code compatible across PA-RISC 1.1 
#	and 2.0 HP workstations and servers, use the option.  
#
#	+DSmodel --  Use the instruction scheduler tuned to the model
#	specified. model can be a model number, PA-RISC architecture 
#	designation or PA-RISC processor name. See the file:
#	/opt/langtools/lib/sched.models for a list of model numbers and 
#	processor names.  
#
#	+Oopt --  Invoke optimizations selected by opt. Defined values 
#	for opt are:
#
#	0    Perform minimal optimizations.  
#	1    Perform optimizations within basic blocks only.
#	2    Perform level 1 and global optimizations. Same as -O.
#	3    Perform level 2 as well as interprocedural global opts.
#	4    Perform level 3 as well as doing link time optimizations.
#	Also sends +Oprocelim and +Ofastaccess to the linker.
#
# Linker flags 
#	-lm -- Needed for math library
# --------------------------------------------------------------- 
SHELL = /bin/sh

# Define a name for the executable
PROJECT = as2htm

# Installation directory for the application and config files
INSTALL_DIR = ../../bin

# Macro for path separator
PATHSEP=/

# Setup additional paths for includes and source code
AS2HTM_PATH = .
HTMLDRV_PATH = ../../src

ADD_INC_PATHS = -I../../include

# Setup define macros
DEFMACS = -D__UNIX__

# Define macros for compiler and linker
CC = cc
CPP = CC
LINKER = ld

# Define compiler and linker flags macros
CFLAGS= -v +a1 +DAportable -pta $(ADD_INC_PATHS) $(DEFMACS)
COMPILE_ONLY = -c
OUTPUT = -o
LFLAGS =  

# Build dependency rules
# ===============================================================
HTMLDRV_DEP = ../../include/htmldrv.h

AS2HTM_DEP = ../../include/htmldrv.h
# ===============================================================

# Compile the files and build the executable
# ===============================================================
all:	$(PROJECT)

htmldrv.o:	$(HTMLDRV_PATH)$(PATHSEP)htmldrv.cpp $(HTMLDRV_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) \
	$(HTMLDRV_PATH)$(PATHSEP)htmldrv.cpp

as2htm.o:	$(AS2HTM_PATH)$(PATHSEP)as2htm.cpp $(AS2HTM_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) \
	$(AS2HTM_PATH)$(PATHSEP)as2htm.cpp

# Make the executable
OBJECTS = htmldrv.o as2htm.o 

$(PROJECT):	$(OBJECTS)
	$(CPP) $(CFLAGS) $(OBJECTS) $(OUTPUT) $(PROJECT) 
# ===============================================================

# Install the binaries and config files to the bin directory
# ===============================================================
install:
	echo Installing $(PROJECT) binaries to the bin directory
	cp $(PROJECT) $(INSTALL_DIR)/. 
# ===============================================================

# Remove object files and the executable after running make 
# ===============================================================
clean:
	echo Removing all OBJECT files from working directory...
	rm -f *.o 

	echo Removing template repository from working directory...
	rm -r -f ptrepository

	echo Removing EXECUTABLE file from working directory...
	rm -f $(PROJECT)
# --------------------------------------------------------------- 
#####################
#### End of File ####
#####################
