#######################
#### Start of File ####
#######################
# --------------------------------------------------------------- 
# Makefile Contents: Make file for the hexdump program
# C/C++ Compiler Used: GNU g++ 2.7.2.1 
# Produced By: Doug Gaer
# File Creation Date: 02/13/1996 
# Date Last Modified: 03/17/1999
# --------------------------------------------------------------- 
# --------------- Makefile Description and Details -------------- 
# --------------------------------------------------------------- 
# Complier Flags 
#       v                   -- Echo compilation
#       g                   -- Enable debugging
#       Wall                -- Turn on warnings 
#       -fhandle-exceptions -- Enable C++ exception handling
#       -frtti              -- Enable C++ Run-Time Type Information
# --------------------------------------------------------------- 
SHELL = /bin/sh

# Define a name for the executable
PROJECT = hexdump

# Installation directory for the application and config files
INSTALL_DIR = ../../bin

# Macro for path separator
PATHSEP=/

# Setup additional paths for includes and source code
HEXDUMP_PATH =.
HXCRC_PATH =.

ADD_INC_PATHS = 

# Setup define macros
DEFMACS = 

# Define macros for compiler and linker
CC = gcc
CPP = g++
LINKER = ld

# Define compiler and linker flags macros
CFLAGS= -fhandle-exceptions $(ADD_INC_PATHS) $(DEFMACS)
COMPILE_ONLY = -c
OUTPUT = -o
LFLAGS =  

# Build dependency rules
# ===============================================================
HEXDUMP_DEP = $(HXCRC_PATH)$(PATHSEP)hxcrc.h

HXCRC_DEP = $(HXCRC_PATH)$(PATHSEP)hxcrc.h
# ===============================================================

# Compile the files and build the executable
# ===============================================================
all:	$(PROJECT)

hexdump.o:	$(HEXDUMP_PATH)$(PATHSEP)hexdump.cpp $(HEXDUMP_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) \
	$(HEXDUMP_PATH)$(PATHSEP)hexdump.cpp

hxcrc.o:	$(HXCRC_PATH)$(PATHSEP)hxcrc.cpp $(HXCRC_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) \
	$(HXCRC_PATH)$(PATHSEP)hxcrc.cpp

# Make the executable
OBJS = hexdump.o hxcrc.o

$(PROJECT):	$(OBJS)
	$(CPP) $(CFLAGS) $(OBJS) $(OUTPUT) $(PROJECT) 
# ===============================================================

# Install the binaries and config files to the bin directory
# ===============================================================
install:
	echo Installing $(PROJECT) binaries to the bin directory
	cp $(PROJECT) $(INSTALL_DIR)/. 
# ===============================================================

# Remove object files and the executable after running make 
# ===============================================================
clean:
	echo Removing all OBJECT files from working directory...
	rm -f *.o 

	echo Removing EXECUTABLE file from working directory...
	rm -f $(PROJECT)
# --------------------------------------------------------------- 
#####################
#### End of File ####
#####################
